Provable Markets

ContractService

AcceptAwaitingContractReturn

PATH: /aurora.core.apiengine.contractsv1.ContractService/AcceptAwaitingContractReturn

SecurityBearer
Request
Request Body schema: application/json
required
id
required
string

Return identifier (persistent identifier inside Aurora system for the return)

request_id
string

An optional identifier provided by the user to help associate the order request any internal record keeping. If the same value is observed recently then the request will be rejected.

Responses
200

A successful response

Response Schema: application/json
id
required
string

Return identifier (persistent identifier inside Aurora system for the return)

AcceptRateModification

PATH: /aurora.core.apiengine.contractsv1.ContractService/AcceptRateModification

SecurityBearer
Request
Request Body schema: application/json
required
id
required
string

Id of rate_modification that is to be modified

request_id
string

User populated id of this request

Responses
200

A successful response

Response Schema: application/json
id
required
string

Id of rate_modification that was created

status
required
string (aurora.core.consts.contractratemodification.ContractRateModificationStatus)

Different stages of a rate renegotiation

Enum: "PROPOSED" "ACCEPTED" "FINALIZED" "REJECTED" "CANCELED" "DROPPED" "EXPIRED"

BuyInContract

PATH: /aurora.core.apiengine.contractsv1.ContractService/BuyInContract

Buying-In Against Recalled Contracts

Where a lender has requested a recall of a contract, but the borrower has not returned the shares before the allowed_execution_date indicated on the Contract Recall, the lender may buy-in the shares against the borrower.

Aurora acts as a gateway to capture the purchase price and quantity of this buy-in, allowing the lender to reclaim the costs of the buy-in against the borrower, and adjusting the contract records within Aurora and downstream clearing and settlement. The lender may submit the execution price and quantity of shares by submitting this message.

Note that buy-ins are allocated against outstanding recalls for the indicated contract on a first-in-first-out basis, and therefore a contract_recall_id is not supported in this message.

The submitted buy-in details must be processed by DTC before updating outstanding contracts and recall request(s) within Aurora.

SecurityBearer
Request
Request Body schema: application/json
required
avg_price_per_share
required
string

Average price per share for buy-in

id
required
string

Contract identifier (persistent contract identifier inside Aurora system)

quantity
required
string <int64>

Amount of shares to buy-in

request_id
string

An optional identifier provided by the user to help associate the order request any internal record keeping. If the same value is observed recently then the request will be rejected.

Responses
200

A successful response
Returns current status of the BuyIn request

Response Schema: application/json
required
object (aurora.core.apiengine.contractsv1.BuyIn)

Fields: id, contract_id, quantity, price, status

CancelAllPendingReturns

PATH: /aurora.core.apiengine.contractsv1.ContractService/CancelAllPendingReturns

SecurityBearer
Request
Request Body schema: application/json
required
contract_id
required
string

Contract identifier (persistent contract identifier inside Aurora system)

request_id
string

An optional identifier provided by the user to help associate the order request any internal record keeping. If the same value is observed recently then the request will be rejected.

Responses
200

A successful response

Response Schema: application/json
contract_id
required
string

Contract identifier (persistent contract identifier inside Aurora system)

CancelAllRecalls

PATH: /aurora.core.apiengine.contractsv1.ContractService/CancelAllRecalls

SecurityBearer
Request
Request Body schema: application/json
required
id
required
string

Contract identifier (persistent identifier inside Aurora system)

request_id
string

An optional identifier provided by the user to help associate the order request any internal record keeping. If the same value is observed recently then the request will be rejected.

Responses
200

A successful response

Response Schema: application/json
id
required
string

Contract identifier (persistent contract identifier inside Aurora system)

CancelAwaitingContractReturn

PATH: /aurora.core.apiengine.contractsv1.ContractService/CancelAwaitingContractReturn

SecurityBearer
Request
Request Body schema: application/json
required
id
required
string

Return identifier (persistent identifier inside Aurora system for the return)

request_id
string

An optional identifier provided by the user to help associate the order request any internal record keeping. If the same value is observed recently then the request will be rejected.

Responses
200

A successful response

Response Schema: application/json
id
required
string

Return identifier (persistent identifier inside Aurora system for the return)

CancelContract

PATH: /aurora.core.apiengine.contractsv1.ContractService/CancelContract

CancelContract can be use to cancel a Pending Contract

SecurityBearer
Request
Request Body schema: application/json
required
id
required
string

Contract identifier (persistent identifier inside Aurora system)

request_id
string

User populated id of this request

Responses
200

A successful response

Response Schema: application/json
id
required
string

Contract identifier (persistent identifier inside Aurora system)

CancelRateModification

PATH: /aurora.core.apiengine.contractsv1.ContractService/CancelRateModification

SecurityBearer
Request
Request Body schema: application/json
required
id
required
string

Id of rate_modification that is to be modified

request_id
string

User populated id of this request

Responses
200

A successful response

Response Schema: application/json
id
required
string

Id of rate_modification that was created

status
required
string (aurora.core.consts.contractratemodification.ContractRateModificationStatus)

Different stages of a rate renegotiation

Enum: "PROPOSED" "ACCEPTED" "FINALIZED" "REJECTED" "CANCELED" "DROPPED" "EXPIRED"

CancelRecallContract

PATH: /aurora.core.apiengine.contractsv1.ContractService/CancelRecallContract

SecurityBearer
Request
Request Body schema: application/json
required
contract_id
required
string

Contract identifier (persistent identifier inside Aurora system)

id
required
string

Identifier of the recall to cancel (persistent identifier inside Aurora system)

request_id
string

An optional identifier provided by the user to help associate the order request any internal record keeping. If the same value is observed recently then the request will be rejected.

Responses
200

A successful response

Response Schema: application/json
required
object (aurora.core.apiengine.contractsv1.Recall)

Fields: id, contract_id, recall_status, quantity, allowed_execution_date, initiator_company_id

CancelSinglePendingReturn

PATH: /aurora.core.apiengine.contractsv1.ContractService/CancelSinglePendingReturn

SecurityBearer
Request
Request Body schema: application/json
required
contract_id
required
string

Contract identifier (persistent contract id inside Aurora system)

id
required
string

Return identifier to be canceled (persistent identifier inside Aurora system for the return)

request_id
string

An optional identifier provided by the user to help associate the order request any internal record keeping. If the same value is observed recently then the request will be rejected.

Responses
200

A successful response

Response Schema: application/json
contract_id
required
string

Contract identifier (persistent contract id inside Aurora system)

id
required
string

Return identifier which is canceled (persistent identifier inside Aurora system for the return)

CreateRateModification

PATH: /aurora.core.apiengine.contractsv1.ContractService/CreateRateModification

SecurityBearer
Request
Request Body schema: application/json
required
contract_id
required
string

Contract identifier (persistent identifier inside Aurora system)

required
object (aurora.core.common.protos.PbRateDetails)

Fields: rate, benchmark

request_id
string

User populated id of this request

Responses
200

A successful response

Response Schema: application/json
contract_id
required
string

Contract identifier (persistent identifier inside Aurora system)

id
required
string

Id of rate_modification that was created

required
object (aurora.core.common.protos.PbRateDetails)

Fields: rate, benchmark

status
required
string (aurora.core.consts.contractratemodification.ContractRateModificationStatus)

Different stages of a rate renegotiation

Enum: "PROPOSED" "ACCEPTED" "FINALIZED" "REJECTED" "CANCELED" "DROPPED" "EXPIRED"

GetContract

PATH: /aurora.core.apiengine.contractsv1.ContractService/GetContract

SecurityBearer
Request
Request Body schema: application/json
required
contract_id
required
string

Contract identifier (persistent identifier inside Aurora system)

Responses
200

A successful response

Response Schema: application/json
required
object (aurora.core.apiengine.contractsv1.Contract)

Current status of the contract according to Aurora
Fields: id, settlement_type, settlement_id, instrument, side, counterparty_id, status, quantity, rate_details, collateral_rate, rounding_rule, interest_due_amount, market_value, contract_value, contract_value_adjustment, created_at, settlement_date, recalled_quantity, returned_quantity, agreement_id, last_close_price, last_quantity, last_market_value, last_contract_value

ListContractHistory

PATH: /aurora.core.apiengine.contractsv1.ContractService/ListContractHistory

ListContractHistory provides a way to query contract events This can be used to get the full history of everything that has happened to a contract or for example to get all the returns that happened on a specific date or for a specific instrument

SecurityBearer
Request
Request Body schema: application/json
required
object (aurora.core.apiengine.contractsv1.ListContractHistoryFilter)

ListContractHistoryFilter specifies the filters applied to the returned events Multiple filters can be set and are combined to create a subset
Fields: event_types, event_time_start, event_time_end, instruments, counterparties, contracts, side, initiator_kind, initiator_id

page_limit
required
integer <int32>

Number of events to fetch per page (max=1000)

page_number
required
integer <int32>

Page number to fetch, starting from 1

Array of objects (aurora.core.apiengine.contractsv1.ListContractHistorySort)

Sorting options, multiple can be specified

Responses
200

A successful response

Response Schema: application/json
Array of objects (aurora.core.apiengine.contractsv1.ContractHistoryEvent)

List of events

total_entries
required
string <int64>

Total number of events

ListContracts

PATH: /aurora.core.apiengine.contractsv1.ContractService/ListContracts

SecurityBearer
Request
Request Body schema: application/json
required
counterparty_ids
Array of strings

Counterparty ID filter - optional

created_at_end
string

Filter contracts created before time - in RFC3339 with millisecond precision - optional

created_at_start
string

Filter contracts created after time - in RFC3339 with millisecond precision - optional

end_date
string

Date until contracts created (inclusive, YYYY-MM-DD) filter - optional

id
string

Contract identifier (persistent contract identifier inside Aurora system) filter - optional

instrument
string

Instrument (CUSIP or Ticker) filter - optional

page_limit
required
integer <int32>

Number of contracts to fetch per page (max=1000)

page_number
required
integer <int32>

Page number to fetch, starting from 1

side
string (aurora.core.consts.common.Side)
Enum: "BORROW" "LOAN"
start_date
string

Date after contracts created (inclusive, YYYY-MM-DD) filter - optional

status_filter
string (aurora.core.apiengine.contractsv1.ListContractsStatusFilter)
Enum: "OPEN" "CLOSED"
Responses
200

A successful response

Response Schema: application/json
Array of objects (aurora.core.apiengine.contractsv1.Contract)

Current details of the contract(s)

total_count
required
string <int64>

Total number of contracts

ListRateModifications

PATH: /aurora.core.apiengine.contractsv1.ContractService/ListRateModifications

SecurityBearer
Request
Request Body schema: application/json
required
contract_id
string

Filter by Contract identifier (persistent identifier inside Aurora system) - optional

counterparty_ids
Array of strings

Filter by Counterparty IDs - optional

id
string

Filter by Id of the rate_modification (assigned by Aurora) - optional

instrument
string

Filter by Instrument (CUSIP or Ticker) - optional

request_id
string

User populated id of this request

side
string (aurora.core.consts.common.Side)
Enum: "BORROW" "LOAN"
Responses
200

A successful response

Response Schema: application/json
Array of objects (aurora.core.apiengine.contractsv1.RateModificationDetails)

Details of the rate_modification(s)

total_count
required
string <int64>

Total number of rate_modifications

ListRecalls

PATH: /aurora.core.apiengine.contractsv1.ContractService/ListRecalls

SecurityBearer
Request
Request Body schema: application/json
required
contract_id
string

Contract identifier (persistent identifier inside Aurora system) - optional

id
string

Recall id (persistent recall identifier inside Aurora system) - optional

instrument
string

Instrument (CUSIP or Ticker) - optional

request_id
string

An optional identifier provided by the user to help associate the order request any internal record keeping. If the same value is observed recently then the request will be rejected.

Responses
200

A successful response

Response Schema: application/json
Array of objects (aurora.core.apiengine.contractsv1.Recall)

Details of the recall(s)

total_count
required
string <int64>

Total number of recalls

RecallContract

PATH: /aurora.core.apiengine.contractsv1.ContractService/RecallContract

SecurityBearer
Request
Request Body schema: application/json
required
contract_id
required
string

Contract identifier (persistent identifier inside Aurora system)

quantity
required
string <int64>

Amount of shares to recall

request_id
string

An optional identifier provided by the user to help associate the order request any internal record keeping. If the same value is observed recently then the request will be rejected.

Responses
200

A successful response

Response Schema: application/json
required
object (aurora.core.apiengine.contractsv1.Recall)

Fields: id, contract_id, recall_status, quantity, allowed_execution_date, initiator_company_id

RejectAwaitingContractReturn

PATH: /aurora.core.apiengine.contractsv1.ContractService/RejectAwaitingContractReturn

SecurityBearer
Request
Request Body schema: application/json
required
id
required
string

Return identifier (persistent identifier inside Aurora system for the return)

request_id
string

An optional identifier provided by the user to help associate the order request any internal record keeping. If the same value is observed recently then the request will be rejected.

Responses
200

A successful response

Response Schema: application/json
id
required
string

Return identifier (persistent identifier inside Aurora system for the return)

RejectRateModification

PATH: /aurora.core.apiengine.contractsv1.ContractService/RejectRateModification

SecurityBearer
Request
Request Body schema: application/json
required
id
required
string

Id of rate_modification that is to be modified

request_id
string

User populated id of this request

Responses
200

A successful response

Response Schema: application/json
id
required
string

Id of rate_modification that was created

status
required
string (aurora.core.consts.contractratemodification.ContractRateModificationStatus)

Different stages of a rate renegotiation

Enum: "PROPOSED" "ACCEPTED" "FINALIZED" "REJECTED" "CANCELED" "DROPPED" "EXPIRED"

ReturnContract

PATH: /aurora.core.apiengine.contractsv1.ContractService/ReturnContract

SecurityBearer
Request
Request Body schema: application/json
required
contract_id
required
string

Contract identifier (persistent contract identifier inside Aurora system)

quantity
required
string <int64>

Amount of shares to return

request_id
string

An optional identifier provided by the user to help associate the order request any internal record keeping. If the same value is observed recently then the request will be rejected.

Responses
200

A successful response

Response Schema: application/json
contract_id
required
string

Contract identifier (persistent identifier inside Aurora system)

required
object (aurora.core.apiengine.contractsv1.ContractReturn)

Fields: id, contract_id, quantity, status